#ifndef __MEDIAVIEW_H__
#define __MEDIAVIEW_H__

#include <QtGui>
#include <QtNetwork>
#include <phonon>
#include "View.h"
#include "ListModel.h"

class MediaView : public QWidget, public View {
    Q_OBJECT

public:
    MediaView(QWidget *parent);
    void appear() {}

    ~MediaView();

    void disappear();
    QMap<QString, QVariant> metadata() {
        QMap<QString, QVariant> metadata;
        metadata.insert("title", query);
        metadata.insert("description", tr("You're watching \"%1\"").arg(query));
        return metadata;
    }
    void setMediaObject(Phonon::MediaObject *mediaObject);

public slots:
    void setQuery(QString query);
    void pause();
    void stop();
    void skip();
    void fullscreen();
    void openWebPage();

private slots:
    void stateChanged(Phonon::State newState, Phonon::State oldState);
    void activeRowChanged(int);
    void itemActivated(const QModelIndex &index);
    void aboutToFinish();
    void currentSourceChanged(const Phonon::MediaSource source);
    void replyFinished(QNetworkReply*);

private:

    QString query;

    QListView *listView;
    ListModel *listModel;

    // phonon
    Phonon::MediaObject *mediaObject;
    Phonon::VideoWidget *videoWidget;

};

#endif // __MEDIAVIEW_H__
