#ifndef __SEARCHVIEW_H__
#define __SEARCHVIEW_H__

#include <QtGui>
#include "View.h"
#include "searchlineedit.h"

class SearchView : public QWidget, public View {

    Q_OBJECT

public:
    SearchView(QWidget *parent);

    void appear() {
        updateRecentKeywords();
        queryEdit->clear();
        queryEdit->setFocus(Qt::OtherFocusReason);
    }

    void disappear() {}

    QMap<QString, QVariant> metadata() {
        QMap<QString, QVariant> metadata;
        metadata.insert("title", "");
        metadata.insert("description", tr("Let's play some video!"));
        return metadata;
    }

public slots:
    void watch(QString query);

signals:
    void search(QString query);

private slots:
    void watch();

private:
    void updateRecentKeywords();

    SearchLineEdit *queryEdit;
    QVBoxLayout *recentKeywordsLayout;


};

#endif // __SEARCHVIEW_H__
