#ifndef PRETTYITEMDELEGATE_H
#define PRETTYITEMDELEGATE_H

#include <QModelIndex>
#include <QStyledItemDelegate>
#include <QTimer>

class QPainter;


namespace Playlist {

    class PrettyItemDelegate : public QStyledItemDelegate {

    public:
        PrettyItemDelegate( QObject* parent = 0 );
        ~PrettyItemDelegate();

        QSize sizeHint( const QStyleOptionViewItem&, const QModelIndex& ) const;
        void paint( QPainter*, const QStyleOptionViewItem&, const QModelIndex& ) const;

    private:
        void paintBody( QPainter*, const QStyleOptionViewItem&, const QModelIndex& ) const;

        QPointF centerImage( const QPixmap&, const QRectF& ) const;

        /**
             * Paints a marker indicating the track is active
             */
        void paintActiveOverlay( QPainter *painter, qreal x, qreal y, qreal w, qreal h ) const;

        static const qreal THUMB_WIDTH;
        static const qreal THUMB_HEIGHT;
        static const qreal MARGIN;
        static const qreal MARGINH;
        static const qreal MARGINBODY;
        static const qreal PADDING;
        /*
        static QFontMetricsF* s_nfm; //normal
        static QFontMetricsF* s_ifm; //italic
        static QFontMetricsF* s_bfm; //bold
        */

    };
}

#endif

